package serializer

import (
	"fonchain-artshow/cmd/model"
	"fonchain-artshow/pb/test"
	"fonchain-artshow/pkg/m"
	"strings"
	"time"
)

func BuildArtShowM(in *test.SaveShowReq) (out *model.ArtShow) {
	out = new(model.ArtShow)
	if in.ID == 0 {
		out.ShowSeq = strings.Join([]string{m.ARTSHOW_PREFIX, time.Now().Format("20060102150405")}, "")
	} else {
		out.ID = uint(in.ID)
	}
	out.ShowName = in.ShowName
	out.ArtistName = in.ArtistName
	out.ArtistID = in.ArtistID
	out.ArtworkNum = in.ArtworkNum
	out.Price = in.Price
	out.Ruler = in.Ruler
	out.Reward = in.Reward
	out.ShowTime = in.ShowTime
	out.IsShow = int8(in.IsShow)

	return
}

func BuildArtShowListRes(artShows []*model.ArtShow) (out []*test.ShowDetail) {
	out = make([]*test.ShowDetail, 0)
	for i := 0; i < len(artShows); i++ {
		artShowM := BuildArtShowRpc(artShows[i])
		out = append(out, artShowM)
	}
	return
}

func BuildArtShowRpc(artShowM *model.ArtShow) (out *test.ShowDetail) {
	out = new(test.ShowDetail)
	out.ID = int64(artShowM.ID)
	out.ShowSeq = artShowM.ShowSeq
	out.ShowName = artShowM.ShowName
	out.ArtistName = artShowM.ArtistName
	out.ArtworkNum = artShowM.ArtworkNum
	out.Ruler = artShowM.Ruler
	out.Price = artShowM.Price
	out.Reward = artShowM.Reward
	out.ShowTime = artShowM.ShowTime
	out.IsShow = int32(artShowM.IsShow)
	return
}
